/*
 * Shader.java
 *
 * Created on 9. Mai 2003, 18:09
 */

package Aufgabe;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.image.*;
import com.sun.j3d.utils.image.TextureLoader;
import java.net.*;


/**
 *
 * @author  Tobias
 */


public class Shader extends java.awt.Component {
    public final static int DIFFUSE  = 3;
    public final static int AMBIENT  = 4;
    public final static int SPECULAR = 5;
    private Material mat;
    private Appearance appear;
   
        //Standard Material
    public Shader() {
      appear = new Appearance();
      mat = new Material();
      setColor(128,128,128, DIFFUSE);
      setShine(50.0f);
    }
    
       //kompiliert das Material
    public Appearance getAppearance() {
     appear.setMaterial(mat);
     return appear;
    };
    
    
    public void setShine(float f) {
        mat.setShininess(f);
    }
    
    public void setColor(int r, int g, int b, int Art) {
      Color3f clr  = new Color3f((float)r/256,(float)g/256,(float)b/256);
      switch (Art) {
          case DIFFUSE : mat.setDiffuseColor(clr);  break;
          case AMBIENT : mat.setAmbientColor(clr);  break;
          case SPECULAR: mat.setSpecularColor(clr); break;
          default : mat.setDiffuseColor(new Color3f(0.5f,0.5f,0.5f));
      }    
    }  
    public void mitTextur(String name) {
        URL url;
        url = this.getClass().getResource("Bilder/" + name.toLowerCase());
        TextureLoader loader = new TextureLoader(url,this);
        ImageComponent2D image = loader.getImage();
        Texture2D texture = new Texture2D(Texture.BASE_LEVEL, Texture.RGBA,
                                        image.getWidth(), image.getHeight());
        texture.setImage(0, image);
        appear.setTexture(texture);
    }

}
